---
title: XRInputSourceEvent
slug: Web/API/XRInputSourceEvent
tags:
  - 3D
  - API
  - AR
  - Graphics
  - Input Sources
  - Inputs
  - Interface
  - Mixed
  - Reality
  - Reference
  - VR
  - Virtual
  - WebXR
  - WebXR API
  - WebXR Device API
  - XR
  - XRInputSourceEvent
  - augmented
  - controllers
  - events
---
<p>{{APIRef("WebXR Device API")}} {{SecureContext_Header}}</p>

<p><span class="seoSummary">The <a href="/en-US/docs/Web/API/WebXR_Device_API">WebXR Device API</a>'s <code><strong>XRInputSourceEvent</strong></code> interface describes an event which has occurred on a WebXR user input device such as a hand controller, gaze tracking system, or motion tracking system.</span> More specifically, they represent a change in the state of an {{domxref("XRInputSource")}}.</p>

<p>To learn more about handling inputs in a WebXR project, see the article <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs">Inputs and input sources</a>.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{domxref("XRInputSourceEvent.XRInputSourceEvent", "XRInputSourceEvent()")}}</dt>
 <dd>Creates and returns a new <code>XRInputSourceEvent</code> object whose properties match those provided in the <code>eventInitDict</code> dictionary provided.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("XRInputSourceEvent.frame", "frame")}} {{ReadOnlyInline}}</dt>
 <dd>An {{domxref("XRFrame")}} object providing the needed information about the event frame during which the event occurred. This frame may have been rendered in the past rather than being a current frame. Because this is an <em>event</em> frame, not an <em>animation</em> frame, you cannot call the {{domxref("XRFrame")}} method {{domxref("XRFrame.getViewerPose", "getViewerPose()")}} on it; instead, use {{domxref("XRFrame.getPose", "getPose()")}}.</dd>
 <dt>{{domxref("XRInputSourceEvent.inputSource", "inputSource")}} {{ReadOnlyInline}}</dt>
 <dd>An {{domxref("XRInputSource")}} object indicating which input source generated the input event.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<p><em>The <code>XRInputSourceEvent</code> interface doesn't define any methods; however, several methods are inherited from the parent interface, {{domxref("Event")}}.</em></p>

<h2 id="Event_types">Event types</h2>

<dl>
 <dt>{{domxref("XRSession.select_event", "select")}}</dt>
 <dd>Sent to an {{domxref("XRSession")}} when the sending input source has fully completed a <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_actions">primary action</a>.</dd>
 <dt>{{domxref("XRSession.selectend_event", "selectend")}}</dt>
 <dd>Sent to an {{domxref("XRSession")}} when an ongoing <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_actions">primary action</a> ends, or when an input source with an ongoing primary action has been disconnected from the system.</dd>
 <dt>{{domxref("XRSession.selectstart_event", "selectstart")}}</dt>
 <dd>Sent to an {{domxref("XRSession")}} when an input source begins its <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_actions">primary action</a>, indicating that the user has begun a command-like input, such as pressing a trigger or button, issuing a spoken command, tapping on a touchpad, or the like.</dd>
 <dt>{{domxref("XRSession.squeeze_event", "squeeze")}}</dt>
 <dd>Sent to an {{domxref("XRSession")}} when the sending input source has fully completed a <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_squeeze_actions">primary squeeze action</a>.</dd>
 <dt>{{domxref("XRSession.squeezeend_event", "squeezeend")}}</dt>
 <dd>Sent to an {{domxref("XRSession")}} when an ongoing <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_squeeze_actions">primary squeeze action</a> ends or when an input source with an ongoing primary squeeze action is disconnected.</dd>
 <dt>{{domxref("XRSession.squeezestart_event", "squeezestart")}}</dt>
 <dd>Sent to an {{domxref("XRSession")}} when an input source begins its <a href="/en-US/docs/Web/API/WebXR_Device_API/Inputs#Primary_squeeze_actions">primary squeeze action</a>, indicating that the user has begun to grab, squeeze, or grip the controller.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>The code below sets up handlers for primary action events in order to determine when the user clicks on (shoots at/pokes at/whatever) objects in the scene.</p>

<pre class="brush: js">xrSession.addEventListener("select", event =&gt; {
  let targetRayPose = event.frame.getPose(event.inputSource.targetRaySpace, myRefSpace);

  if (targetRayPose) {
    let hit = myHitTest(targetRayPose.transform);
    if (hit) {
      /* handle the hit */
    }
  }
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("WebXR","#xrinputsourceevent","XRInputSourceEvent")}}</td>
   <td>{{Spec2("WebXR")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>{{Compat("api.XRInputSourceEvent")}}</div>
